import numpy as np
import sys
import time
import pdb


from util2 import hfs
import util2    #as util

if __name__ == "__main__":    
    if (len(sys.argv) < 2):
        usage = "usage: python %s" % sys.argv[0]
        usage += "<input file> [<output file>] [<error log>]"
        print usage
        sys.exit(1)
    hfs.init(sys.argv[1],'GS')
    u = hfs.u
    if not (util2.util.isUnitary(u)):
        print "Nonunitary initial guess detected."
        sys.exit(1)

    focc = util2.expandNocc(hfs.nocc)
    hfs.Nn = sum(focc[:hfs.Nbasis_n])
    hfs.Np = sum(focc[hfs.Nbasis_n:])
    print 'Np,Nn = ', 2*hfs.Np,2*hfs.Nn   # 2 for p/m K
    iter = 0
    itermax = hfs.itm

#    tConst = []

    # Calculate <H> and the expectation values of the constraint operators for
    # the initial guess u.
    rho = util2.util.calcRho(u, focc)
    Hsp = util2.calcHsp(rho)
    Horb = util2.util.calcOrbOp(Hsp, u)
    Eold = util2.util.totalE(rho)
    Qave = util2.util.calcQ(rho)
    print "Eold,Qave",Eold,Qave
    print 'Qflag',hfs.Qflag

    t0 = time.time()
    # Emulates a "do-while" loop with conditional check at bottom.
    while True:
        if hfs.Qflag == 'C':
#          pdb.set_trace()
          deltaQ = hfs.Qtarget - Qave
          u = util2.resetQ(deltaQ,hfs.Qop,u,focc)
          rho = util2.util.calcRho(u,focc)
          Hsp = util2.calcHsp(rho)
          Horb = util2.util.calcOrbOp(Hsp, u)      
          Eold = util2.util.totalE(rho)
          print 'reset E',Eold
        Qave1 = util2.util.calcQ(rho)
        if hfs.Qflag == 'C':
           Horb = util2.projectZ3(Horb,u,focc)    #  projectZ3 uses hfs.Qop
        u_new  = util2.updateU(u, focc, Horb)
        rho_new = util2.util.calcRho(u_new, focc)
        Enew = util2.util.totalE(rho_new)
        Qave2 = util2.util.calcQ(rho_new)
        rho_diff = rho_new - rho
        err = sum(rho_diff*rho_diff)
        u = u_new
        rho = rho_new
        Hsp = util2.calcHsp(rho)
        if (Enew > Eold):
            print  "energy increased"
#        print 'Enew,Qave_new',Enew,Qave      
#        sys.exit()
        if hfs.lambdaq != 0.0:
          Hsp = Hsp + hfs.lambdaq*hfs.Qop
        Horb = util2.util.calcOrbOp(Hsp, u)


        Eold = Enew
        Qave = Qave2
        iter += 1
        delta = 1.0e-5
        if hfs.update_n:
          new_flag = util2.sort(hfs.evalsL,hfs.focc,hfs.nocc)
          if new_flag:
            err = 1.0
            focc = util2.expandNocc(hfs.nocc)
        if (iter >= itermax) or (err <= delta):
            break


    dt = time.time() - t0

    idx= 0
    print ' idx ib ch  K   p f   E       Q'
    for ib in range(hfs.Nblock):
      ch,par,m = hfs.keys[ib]
      Db = hfs.b2D[ib]
      idx1 = idx+Db
      for ix in range(idx,idx1):
        focc_ix = focc*0.0
        focc_ix[ix] = 1.0
	rho_ix = util2.util.calcRho(u_new, focc_ix)
	Qix = util2.util.calcQ(rho_ix)
        data = (ix,ib,ch,m,par,focc[ix],hfs.evalsL[ix],Qix)
        print '%3i %3i %1i %2i/2 %2i %1i %8.4f %8.3f ' % data
      idx = idx1 




    Qave = util2.util.calcQ(rho)
    print  'niter=%4i   Efinal=%6.4f  Q=%6.1f ' % (iter,Enew,Qave)
   
    print "\ntime elapsed (s): ", dt
    f1 = open('u_new.dat','w')
    for i1 in range(hfs.Ndens):
       ss1 = '%14.10f ' % u[i1]
       f1.write(ss1)
    f1.close()
    f2 = open('n_new.dat','w')
    for i1 in range(hfs.Nblock):
       ss1 = '%3i ' % hfs.nocc[i1]
       f2.write(ss1)
    f2.write('\n')
    for i1 in range(hfs.Nbasis):
       ss1 = '%2i ' % focc[i1]
       f2.write(ss1)
    f2.write('\n')
    f2.close()

    f2.close()
    f3 = open('rho.dat','w')
    for i1 in range(hfs.Ndens):
       ss1 = '%9.6f ' % rho[i1]
       f3.write(ss1)
    f3.close()
    sys.exit()
    f2 =open('results.txt','a')
    ss = ' %8.3f %8.3f %5.2f ' % (E,Q,lambdaq)+str(nocc)+'\n'
    f2.write(ss)
    f2.close()
