import pdb       #; pdb.set_trace()
import numpy as np
import sys
import time
from util2 import hfs
import util2 



if (len(sys.argv) < 2):
      print  "usage: python %s" % sys.argv[0], "<.in file> [< <output file>] "
      sys.exit(1)
hfs.init(sys.argv[1],'FT')
u = hfs.u
if not (util2.util.isUnitary(u)):
        print "Nonunitary initial u matrix."
        sys.exit(1)
focc = hfs.focc
for ii in range(hfs.Nbasis):
      if focc[ii] == 0.0 :  focc[ii] = 1e-5
      if focc[ii] == 1.0 :  focc[ii] = 1.0-1e-5
Sold = util2.entropy(focc)
itermax = hfs.itm
for ii in range(1):
    print ' iter  Z    N    beta     <H>     S    beta*Omega'
    for beta in hfs.betaL:
      iter = 0
      rho = util2.util.calcRho(u, focc)
      Hsp = util2.util.calcHsp(rho)
      Eold = util2.util.totalE(rho)
      bOold = beta*Eold - Sold
      while True:
        rho = util2.util.calcRho(u, focc)
        Hsp = util2.util.calcHsp(rho)
        Horb0 = util2.util.calcOrbOp(Hsp, u)
        u_new = util2.updateU(u, focc, Horb0)
        rho1 = util2.util.calcRho(u_new, focc)
        E1 = util2.util.totalE(rho1)
        if E1 > Eold+1e-6 :
          print 'E1 > Eold',E1,Eold
        Hsp = util2.util.calcHsp(rho1)
        Horb = util2.util.calcOrbOp(Hsp, u_new)
        Horb_diag = util2.util.get_diagonal(Horb)
        alpha_target = Horb_diag*beta
        focc1 = util2.updatef(alpha_target,focc,hfs.Nbasis_n,hfs.Np,hfs.Nn)
        rho2 = util2.util.calcRho(u_new,focc1)
        Hsp2 = util2.util.calcHsp(rho2)
        Horb2 = util2.util.calcOrbOp(Hsp2, u_new)        

        E2 = util2.util.totalE(rho2)
        Snew = util2.entropy(focc1)
        bOnew = beta*E2 - Snew
        df = focc1-focc;  df2= df*df;  errf = sum(df2)
        dHorb = Horb2-Horb0; dH2 = dHorb*dHorb; errH = sum(dH2)
        err = errH + errf
        u = u_new
        focc = focc1
        Eold= E2
        bOold = bOnew
        iter += 1
        if (iter >= itermax) or (err <= hfs.errmax):
            break
        A=2*sum(focc)
        Nn_ave = 2*sum(focc[:hfs.Nbasis_n])
        Np_ave = 2*sum(focc[hfs.Nbasis_n:])
        ss = '%4i %5.2f %5.2f %6.4f %6.4f %6.4f %6.4f' % (iter,\
            Np_ave,Nn_ave,beta,E2,Snew,bOnew)
        print ss

      Qave = util2.util.calcQ(rho)
      print  'niter=%4i beta=%6.4f Efinal= %6.4f Q=%6.1f betaOmega=%6.4f' % (iter,beta,E2,Qave,bOnew)
    if len(hfs.betaL) == 1:
      f1 = open('u_new.dat','w')
      for i1 in range(hfs.Ndens):
        ss1 = '%14.10f\n' % u[i1]
        f1.write(ss1)
      f1.close()
      f2 = open('f_new.dat','w')
      for i1 in range(hfs.Nbasis):      
        ss1 = '%14.10f' % focc[i1]
        f2.write(ss1)
      f2.write('\n')
      f2.close()
      f2 = open('rho_new.dat','w')
      for i1 in range(hfs.Ndens):      
        ss1 = '%14.10f\n' % rho[i1]
        f2.write(ss1)
      f2.close()

    idx= 0
    print ' idx ch  K   p f   E'
    for ib in range(hfs.Nblock):
      ch,par,m = hfs.keys[ib]
      Db = hfs.b2D[ib]
      idx1 = idx+Db
      for ix in range(idx,idx1):
        data = (ix,ch,m,par,focc[ix],hfs.evalsL[ix])
        print '%3i  %1i %2i/2 %2i %8.5f %8.4f' % data
      idx = idx1 
