import sys
import numpy as np

def factor():
  faclog = np.array([0.0]*130)
  faclog[0] = 0
  faclog[1] = 0
  fn = 1
  for m in range(2,130):
    fn += 1
    faclog[m] = faclog[m-1] + np.log(fn)
  return faclog
 
fl = factor()

def clebsch(j1,j2,j3,m1,m2):
  m3 = m1 + m2
  if ((j1+j2+j3)%2 != 0):
    clb = 0.0
    return clb
  else:
    ia = (j1+j2-j3)/2 
    ib = (j3+j1-j2)/2
    ic = (j3+j2-j1)/2
    id = (j1+j2+j3+2)/2
    ie= (j1+m1)/2
    iF = (j1-m1)/2
    ig = (j2+m2)/2
    ih = (j2-m2)/2
    ii = (j3+m3)/2
    ij = (j3-m3)/2
    t0  = fl[ia]+fl[ib]+fl[ic]+fl[ie]+fl[iF]+fl[ig]+fl[ih]
    t1 = 0.5*(np.log(j3+1.0)+t0+fl[ii]+fl[ij]-fl[id])
    t2= np.e**t1
    tt1 = (j3-j2+m1)/2
    tt2 = (j3-j1-m2)/2
    numin = abs(min((j3-j2+m1)/2,((j3-j1-m2)/2),0))+1
    numax = min(((j1+j2-j3)/2),((j1-m1)/2),((j2+m2)/2)) + 1
    kb = (j3-j2+m1)/2+1
    kc = (j3-j1-m2)/2+1
    ff = 0.0
    for num1 in range(numin,numax+1):
      nu = num1-1
      t3=-(fl[nu]+fl[ia-nu]+fl[iF-nu]+fl[ig-nu]+fl[kb+nu-1]+fl[kc+nu-1])
      con = ((-1)**nu)*np.e**t3
      ff = ff+ con
    clb = t2*ff
    return clb

if __name__ == "__main__":
  fl = factor()
  j1,j2,j3,m1,m2 = map(int,sys.argv[1:6])
  clb = clebsch(j1,j2,j3,m1,m2,fl)
  print clb
 